package cn.net.caoyao.cpzshandset.service.presenter.impl.activateWithPack.commonEgg;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.view.View;
import android.widget.Toast;
import cn.net.caoyao.cpzshandset.R;
import cn.net.caoyao.cpzshandset.bean.ActivateBean;
import cn.net.caoyao.cpzshandset.bean.ConfigBean;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.TConfig;
import cn.net.caoyao.cpzshandset.common.util.LogUtil;
import cn.net.caoyao.cpzshandset.common.util.NetWorkUtils;
import cn.net.caoyao.cpzshandset.service.bll.ActivateWithPackBll;
import cn.net.caoyao.cpzshandset.service.bll.PackPackageBll;
import cn.net.caoyao.cpzshandset.service.bll.PackSubLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.ProductBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.caoyao.cpzshandset.service.bll.config.ConfigBll;
import cn.net.caoyao.cpzshandset.service.presenter.OptionHisListStyleConstact;
import cn.net.caoyao.cpzshandset.service.presenter.base.impl.OptionHisListStyleConstactImpl;
import cn.net.caoyao.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.caoyao.cpzshandset.service.thread.impl.common.CommonSubmitAllActivateWithPackThread;
import cn.net.caoyao.cpzshandset.ui.activity.ActivateConfigActivity;
import cn.net.caoyao.cpzshandset.ui.activity.OptionSubListStyleActivity;
import cn.net.caoyao.cpzshandset.ui.adapter.ActivatePackHisListAdapter;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog.DClick;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog.DSure;
import cn.net.caoyao.cpzshandset.ui.weight.DialogUtils;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class CommonEggActivateWithPackListPresenter extends OptionHisListStyleConstactImpl{
	private final OptionHisListStyleConstact.View hisView;
	private Context context;
	private ActivatePackHisListAdapter adapter;
	private List<ActivateBean> aBeans = new ArrayList<ActivateBean>();
	private int createActivateConfigReqCode=1001;
	private int modifyActivateConfigReqCode=1002;
	private ActivateWithPackBll bll;
	private PackPackageBll packageBll;
	private PackSubLabelBll labelBll;
	private ConfigBll configBll;
	private ProductBll productBll;
	private UploadStatusBll uploadStatusBll;
	private TipsDialog tipsDialog;
	private OperationDialog operationDialog;
	private ProgressDialog bProgressDialog = null;
	private int currentHansetVersion = HandsetVersionConstant.HANDSET_UNIVERSAL_EGG_VERSION_MODE;
	private HandsetOperation option_type = HandsetOperation.OPERATION_ACTIVATE_WITH_PACK_CONSTANT;
	
	private Handler mHandler = new Handler(){
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case RequestConstant.SUBMIT_ALL_ACTIVATE_COMPLETE:
				dismissProgress();
				onResume();
				break;
			case RequestConstant.REQUEST_FAIL:
				//请求失败
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				//超时
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				//登录失败
				if (!checkViewAvailable())return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				hisView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_SUCCESS:
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息成功，请在扫码界面中查看详细信息", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_FAIL:
				if (!checkViewAvailable())return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息失败", Toast.LENGTH_SHORT);
				break;
			}
		};
	};
	public CommonEggActivateWithPackListPresenter(Context context,OptionHisListStyleConstact.View hisView) {
		super(hisView, context);
		this.hisView = hisView;
		this.context = context;
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable()) return;
		bll = new ActivateWithPackBll(context);
		configBll = new ConfigBll(context);
		hisView.setPageTitle("生产打包");
		hisView.setMoreOptionText(context.getResources().getString(R.string.new_create_str));
		adapter = new ActivatePackHisListAdapter(aBeans,getProductBll(),getPackageBll());
		hisView.setAdapter(adapter);
	}

	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr,
				tipsMsg, context);
	}
	private UploadStatusBll getUploadStatusBll(){
		if (uploadStatusBll == null) {
			uploadStatusBll = new UploadStatusBll(context);
		}
		return uploadStatusBll;
	}
	private PackPackageBll getPackageBll() {
		if (packageBll == null) {
			packageBll = new PackPackageBll(context);
		}
		return packageBll;
	}

	private PackSubLabelBll getSubLabelBll() {
		if (labelBll == null) {
			labelBll = new PackSubLabelBll(context);
		}
		return labelBll;
	}

	private ProductBll getProductBll() {
		if (productBll == null) {
			productBll = new ProductBll(context);
		}
		return productBll;
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (hisView != null && context != null) {
			b = true;
		}
		return b;
	}

	@Override
	public void onItemClickListener(int position) {
		if (aBeans.size() == 0) {
			return;
		}
		ActivateBean a = aBeans.get(position);
		Intent activateIntent = new Intent(context, OptionSubListStyleActivity.class);
		activateIntent.putExtra("optionMode", option_type);
		activateIntent.putExtra("currentActivateBean", a);
		context.startActivity(activateIntent);
		
//		LogUtil.d(TConfig.Echo,position + "position:" + a.getProduct_date());
		/*if (a.getOption_mode() == Config.SINGLE_OPTION_LABEL_TYPE) {
			//单标激活打包样式
			Intent intent = new Intent(context, SingleLabelScannerActivity.class);
			intent.putExtra("optionMode", option_type);
			intent.putExtra("currentActivateBean", a);
			context.startActivity(intent);
		} else {
			//批量激活打包样式
			Intent intent = new Intent(context, BatchLabelScannerActivity.class);
			intent.putExtra("optionMode", option_type);
			intent.putExtra("currentActivateBean", a);
			context.startActivity(intent);
		}*/
	}

	@Override
	public void onItemLongClickListener(int position) {
		if (!checkViewAvailable())return;
		if (aBeans.size() > 0) {
			showOptionDialog(position);
		}
		
	}

	private void showOptionDialog(final int position) {
		if (operationDialog == null) {
			operationDialog = new OperationDialog(context);
		}
		
		operationDialog.show();
		
		int labelCount = getSubLabelBll().queryLabelCountByOptionId(aBeans.get(position).getId(), option_type.getOption());
		if (labelCount > 0) {
			operationDialog.setDelViewVisiable(View.GONE);
		} else {
			operationDialog.setDelViewVisiable(View.VISIBLE);
		}
		operationDialog.setDClick(position, new DClick() {
			
			@Override
			public void modifyClick() {
				//修改
				if (!checkViewAvailable()) return;
				Intent intent = new Intent(context, ActivateConfigActivity.class);
				intent.putExtra("isCreate", false);
				intent.putExtra("optionMode", option_type.getOption());
				intent.putExtra("currentHisId", aBeans.get(position).getId());
				hisView.startAcForResult(createActivateConfigReqCode, intent);
			}
			
			@Override
			public void delClick() {
				// 删除
				if (!checkViewAvailable()) return;
				String msg = "本条数据还未上传\n\n是否确定删除激活打包数据？\n\n确定删除后\n\n该数据对应的所有信息都会被删除" ;
				showWarnTipDialog(msg,position);
			}

			@Override
			public void searckClick() {
//				if (!checkViewAvailable()) return;
//				if (!NetWorkUtils.isNetworkConnected(context)) {
//					DialogUtils.showSetNetDialog(context);
//					return;
//				}
//				ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
//				if (configBean == null) {
//					hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
//					return;
//				}
//				if (aBeans == null || aBeans.size() == 0) {
//					hisView.showMsgToast("抱歉，当前的激活打包数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
//					return;
//				}
//				
//				List<String> labels = getSingelLabelBll().queryAllLabelStrById(option_type.getOption(), aBeans.get(position).getId());
//				if (labels == null) {
//					hisView.showMsgToast("抱歉，当前的激活打包数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
//					return;
//				}
//				
//				if (labels.size() == 0) {
//					hisView.showMsgToast("抱歉，当前的激活打包数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
//					return;
//				}
//				showProgressDialog("提示", "正在检测标签信息，请稍后……");
//				long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
//				ThreadPoolManager.getThreadPool().execute(new CommonCheckLabelThread(mHandler, deviceId, option_type, aBeans.get(position).getId(), labels, getSingelLabelBll()));				
			}
		});
		
	}
	
	protected void showWarnTipDialog(String msg,final int position) {
		if (tipsDialog == null) {
			tipsDialog = new TipsDialog(context);
		}
		tipsDialog.show();
		tipsDialog.setDelWarnView("警告", msg, position, false, new DSure() {
			
			@Override
			public void sureClick() {
				bll.delActivatePackById(aBeans.get(position));
				aBeans = bll.queryAllActivatePackList();
				adapter.refreshActivateHisData(aBeans);
				hisView.showMsgToast("删除成功！", Toast.LENGTH_SHORT);
			}
		});
		
	}

	@Override
	public void backBtnClick() {
		if (!checkViewAvailable()) return;
		hisView.finishPage();
	}

	@Override
	public void moreOptionClick() {
		if (!checkViewAvailable()) return;
		Intent intent = new Intent(context, ActivateConfigActivity.class);
		intent.putExtra("isCreate", true);
		intent.putExtra("optionMode", option_type.getOption());
		hisView.startAcForResult(createActivateConfigReqCode, intent);
//		hisView.showMsgToast("新建", Toast.LENGTH_SHORT);
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		LogUtil.d(TConfig.Echo, "onActivityResult"+" requestCode:" + requestCode +"  resultCode:" + resultCode);
		
	}

	@Override
	public void onResume() {
		aBeans = bll.queryAllActivatePackList();
//		LogUtil.e(TConfig.Echo, "aBeans:" + aBeans.toString());
		adapter.refreshActivateHisData(aBeans);
		
	}

	@Override
	public void uploadAllHisList() {
		if (!checkViewAvailable()) return;
		if (!NetWorkUtils.isNetworkConnected(context)) {
			DialogUtils.showSetNetDialog(context);
			return;
		}
		ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
		if (configBean == null) {
			hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			return;
		}
		if (aBeans == null || aBeans.size() == 0) {
			hisView.showMsgToast("抱歉，当前的激活打包数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
			return;
		}
		
		List<ActivateBean> valid = getValidActivate();
		if (valid == null || valid.size() == 0) {
			hisView.showMsgToast("抱歉，当前的激活打包数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
			return;
		}
		showProgressDialog("提示", "正在提交激活打包信息，请稍后……");
		long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
		ThreadPoolManager.getThreadPool().execute(new CommonSubmitAllActivateWithPackThread(mHandler, deviceId, getPackageBll(), getSubLabelBll(),getUploadStatusBll(),valid));
	}
	
	private List<ActivateBean> getValidActivate() {
		List<ActivateBean> ascLists = bll.queryAllActivatePackListByASC();
		List<ActivateBean> valid = new ArrayList<>();
		for (ActivateBean activateBean : ascLists) {
			int count = getSubLabelBll().queryLabelCountByOptionId(activateBean.getId(), option_type.getOption());
			if (count > 0) {
				valid.add(activateBean);
			}
			
		}
		return valid;
	}

}
